# Feature Flag Decision

A Feature Flag has an on state and an off state. A different feature is configured for each state.\
When a user accesses a feature that has a Feature Flag applied, the on or off state must be returned. You can perform this state decision through the Hackle SDK.

## isFeatureOn

By passing a **Feature Key** to the `isFeatureOn()` method, you can receive the state result for the user. Then implement logic based on the state.

In the example code below, Feature Key 42 is passed, and the User Identifier for the user whose state is to be determined is "ae03e1adf".

```javascript
// SDK가 준비된 이후에 실행이 되어야합니다. onReady로 감싸는 것을 잊지 마세요.
hackleClient.onReady(function() {

  // 기능 키가 42인 기능 플래그에서 사용자의 상태를 결정합니다.
  // 결정하지 못하는 상황인 경우 false(꺼짐 상태)를 반환합니다.
  const featureOn = hackleClient.isFeatureOn(42, "ae03e1adf");

  // 상태 별 로직
  if (featureOn) {
    // ON 기능
  } else {
    // OFF 기능
  }
});
```

## featureFlagDetail

The `featureFlagDetail()` method works the same as the `isFeatureOn()` method and additionally provides the reason for the state decision. It is useful for checking whether Override is working correctly or when the result ratio seems unusual relative to the configured Traffic Allocation.

You must pass the Feature Key as a parameter. In the example code below, Feature Key 42 is passed.

```javascript
hackleClient.onReady(function() {
  // 상태 결정 상세
  const decision = hackleClient.featureFlagDetail(42, "ae03e1adf");
  // 기능 on/off 여부
  const featureOn = decision.isOn;
  // 상태 결정 사유
  const reason = decision.reason;
});
```

The state decision reason is returned in the form of **`SDK_NOT_READY`**. Refer to the table below for details.

<table><thead><tr><th width="233.71875">Decision Reason</th><th width="370.8046875">Description</th><th>Distribution Result</th></tr></thead><tbody><tr><td><code>SDK_NOT_READY</code></td><td>The SDK is not ready to use.<br>(e.g., initialization attempted with an invalid SDK Key)</td><td>Default state<br>(off)</td></tr><tr><td><code>FEATURE_FLAG_NOT_FOUND</code></td><td>No Feature Flag was found for the provided Feature Key.<br>The Feature Key may be incorrect, or the Feature Flag may be archived.</td><td>Default state<br>(off)</td></tr><tr><td><code>FEATURE_FLAG_INACTIVE</code></td><td>The Feature Flag is in the off state.</td><td>Default state<br>(off)</td></tr><tr><td><code>INDIVIDUAL_TARGET_MATCH</code></td><td>Matched by Individual Targeting.</td><td>State configured by<br>Individual Targeting</td></tr><tr><td><code>TARGET_RULE_MATCH</code></td><td>Matched by User Targeting.</td><td>State configured by User Targeting</td></tr><tr><td><code>DEFAULT_RULE</code></td><td>Did not match either Individual Targeting or User Targeting.</td><td>State configured by<br>default rule</td></tr><tr><td><code>EXCEPTION</code></td><td>An unknown error occurred.</td><td>Default state<br>(off)</td></tr></tbody></table>

{% hint style="info" %}
When using the Node.js SDK, duplicate exposure events for the same Feature Flag Distribution result generated by the same user within 1 minute are deduplicated. Events within 1 minute are counted as one.
{% endhint %}

## Feature Flag Parameter Settings

* You can also receive the parameter values for the state decision through the `featureFlagDetail()` method.
* You can use the config object and `get()` method to retrieve and use the Parameter Settings values configured on the Feature Flag screen. If you change a value on the Feature Flag parameter settings screen, the updated value is applied to your code.

```javascript
hackleClient.onReady(function() {
  const decision = hackleClient.featureFlagDetail(featureKey, "ae03e1adf");

  //상태 결정 상세에서 get() 메소드를 통해 parameter 값 가져오기
  const parameterValue = decision.get(parameterKey, defaultValue)

  // string 유형의 parameter값 예제
  const strValue = decision.get("parmeterKey", "defaultValue")
});
```

* The `parameterKey` of the `get()` method is the key configured in the Feature Flag parameter settings, and `defaultValue` is the value returned when the state decision fails or an invalid parameter type value is provided.
* To receive the configured information correctly, you must enter a value of the type that matches the parameter type you configured in `defaultValue`.
* Since JSON type can be received as a string, you must enter the `defaultValue` as a string type for JSON type.
* The parameter types provided by the SDK are string, number, and boolean. The JSON type configured on the Feature Flag screen can be received as a string. The default value for JSON type must be entered as a string type.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/nodejs/node-feature-flag.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
